/*
	facility.pl

   	facility check main and conflict check
*/
facilityCheckMain :-
%	recorded(sub_int,(SubintId,_,_,_,_),_),
%	clear_record(path),
%	clear_record(max_id),
%	recordz(max_id,(SubintId,0),_),
	recorded(sub_int,(SubintId,Sc,Mc,L,NDT),_),
%	display(NDT),ttynl,
	write(SubintId),nl,nl,
	pathForAll(SubintId,1,NDT),
	nl,
	uniqCallerRecord(SubintId),
	recorded(caller,(SubintId,Callers,1),_),
%%%%
	errorForTrans(SubintId,Callers,1,NDT),nl,
	write('Check path set that this subinterval uses.'),nl,
	subintConflictCheck(SubintId,Callers,1,NDT,[],[],Path,Pconf,[],[],Ctl,Cconf),
	getOpStatus(Pconf,Path,Cconf,Ctl,Status,Conf),
	printCallers(Callers,0),
	facilityCheckSub(SubintId,Callers,Status,Conf,Path,Ctl),
	nl,
	fail.
facilityCheckMain :-
	!,
	show_record(path),nl.

facilityCheckSub(SubintId,Callers,Status,Conf,Path,Ctl) :-
	Status == conflict,
	write('Conflict happens in '),write(Conf),nl,
	!.
facilityCheckSub(SubintId,Callers,Status,Conf,Path,Ctl) :-
	Status == fail,
	write('Fail. The data pathes cannot implement data transfers in this subinterval.'),nl,
	!.
facilityCheckSub(SubintId,Callers,Status,Conf,Path,Ctl) :-
	Status == success,
	write('Seccess. Path is '),write(Path),nl,
	write(' Control line is '),write(Ctl),nl,
	append([(SubintId,0)],Callers,Set),
	getFSid(SubintId,Callers,Id),
	recordz(facility,(Set,Id,Path,Ctl),_),
	!.

getFSid(SubintId,Callers,Id) :-
	!,
	recorded(caller,(SubintId,Callers,Id),Ref),
	Nid is Id + 1,
	erase(Ref),
	recordz(caller,(SubintId,Callers,Nid),_).

printCallers(Callers,Tab) :-
	Callers \== [],
	!,
	tab(Tab),write('Called by '),write(Callers),nl.
printCallers(Callers,Tab) :-
	!.

uniqCallerRecord(SubintId) :-
	recorded(caller,(SubintId,Callers,_),Ref1),
	recorded(caller,(SubintId,Callers,_),Ref2),
	Ref1 \== Ref2,
	erase(Ref2),
	fail.

uniqCallerRecord(SubintId) :-
	recorded(caller,(SubintId,Callers1,_),Ref1),
	recorded(caller,(SubintId,Callers2,_),Ref2),
	append(Callers2,C1,Callers1),
	C1 \== [],
	erase(Ref2),
	fail.
uniqCallerRecord(SubintId) :- 
	!.

pathForAll(SubintId,Id,Max) :- 
	Id > Max,
	!.
pathForAll(SubintId,Id,Max) :- 
	Tab is 2,
	recorded(data_trans,(SubintId,Id,(To,CT),(From,CF)),_),
	write('data_trans  id:'),write(Id),write('  '),
	write(To),write(' <- '),write(From),nl,
	operation_expand(To,ET,_), 
	operation_expand(From,EF,_),
	pathForAllSub(SubintId,Id,ET,EF,CT,CF,Tab),
	Nid is Id + 1,
	pathForAll(SubintId,Nid,Max).

pathForAllSub(SubintId,Id,ET,EF,CT,CF,Tab) :-
	substituteForOp(ET,SubintId,CT,RegT,C1),
	substituteForOp(EF,SubintId,CF,RegF,C2),
	longer(C1,C2,Callers),
	recordz(caller,(SubintId,Callers,1),_),
	operation_creat(CrT,RegT),
	operation_creat(CrF,RegF),
	pathForOne(SubintId,Callers,Id,CrT,CrF,Tab), 
%	maxId(SubintId,Id),
	fail.
pathForAllSub(SubintId,Id,ET,EF,CT,CF,Tab).

pathForOne(SubintId,Callers,Id,To,From,Tab) :-
	Callers \== [],
	tab(Tab),write('Called by  '),write(Callers),nl,
	Tab1 is Tab + 2,
	pathForOneMain(SubintId,Callers,Id,To,From,Tab1).
pathForOne(SubintId,Callers,Id,To,From,Tab) :-
	Callers == [],
	pathForOneMain(SubintId,Callers,Id,To,From,Tab).

pathForOneMain(SubintId,Callers,Id,To,From,Tab) :-
	tab(Tab),write('Register level  '),
	write(To),write(' <- '),write(From),nl,
	Tab1 is Tab + 2,
	pathSearch(To,From,Path,Ctl,Status,Tab1), 
%	Path \== error,
	Status == success,
	recordz(path,([SubintId,Callers],Id,Path,Ctl),_), 
	tab(Tab),write('Success!'),nl,
	tab(Tab),write('Retry!'),nl,
	fail.
pathForOneMain(SubintId,Callers,Id,To,From,Tab) :-
	recorded(path,([SubintId,Callers],Id,Path,Ctl),_), 
	tab(Tab),write('No other success!'),nl,
	!.
pathForOneMain(SubintId,Callers,Id,To,From,Tab) :-
	tab(Tab),write('Fail!'),nl,
	!.

errorForTrans(SubintId,Callers,Id,Max) :-
	Id > Max,
	!.
errorForTrans(SubintId,Callers,Id,Max) :-
	recorded(path,([SubintId,C1],Id,_),_),
	append(C1,_,Callers),
	!,
	Nid is Id + 1,
	errorForTrans(SubintId,Callers,Nid,Max).
errorForTrans(SubintId,Callers,Id,Max) :-
	!,
	recordz(path,([SubintId,Callers],Id,error,error),_),
	write(('The data_path do not implement this data_trans. The id is ')),
	write((Callers,Id)),put(46),nl,
	Nid is Id + 1,
	errorForTrans(SubintId,Callers,Nid,Max).

subintConflictCheck(SubintId,Callers,TransId,Max,Path,Pconf,Path,Pconf,Ctl,Cconf,Ctl,Cconf) :-		
	TransId > Max,
	!.
subintConflictCheck(SubintId,Callers,TransId,Max,Apath,Pconf0,Path,Pconf,Actl,Cconf0,Ctl,Cconf) :-		
	!,
	recorded(path,([SubintId,C1],TransId,Cpath,Cctl),_),
	append(C1,_,Callers),
	pathConflictCheck(Cpath,Apath,Pconf0,Tpath,Pconf1),
	ctlConflictCheck(Cctl,Actl,Cconf0,Tctl,Cconf1),
	Nid is TransId + 1,
	subintConflictCheck(SubintId,Callers,Nid,Max,Tpath,Pconf1,Path,Pconf,Tctl,Cconf1,Ctl,Cconf).

pathConflictCheck(_,error,_,error,[]) :- !.
pathConflictCheck(error,_,_,error,[]) :- !.
pathConflictCheck(F1,F2,Co,Output,CoOut) :-
	!,
	pathConflictCheckMain(F1,F2,Co,Output,CoOut).

pathConflictCheckMain([],F2,CO,F2,CO) :- 
	!.
pathConflictCheckMain([F0|F1],F2,Co,Output,CoOut) :-
	F0 = [Path,Faci],
	member([Path,Faci],Co),
	!,
	pathConflictCheckMain(F1,F2,Co,Output,CoOut).
pathConflictCheckMain([F0|F1],F2,Co,Output,CoOut) :-
	F0 = [Path,Faci],
	member1([_,Faci],Co,_),
	!,
	pathConflictCheckMain(F1,F2,[F0|Co],Output,CoOut).
pathConflictCheckMain([F0|F1],F2,Co,Output,CoOut) :-
	F0 = [Path,Faci],
	member1([X,Faci],F2,XX),
	!,
	pathConflictCheckSub(F0,XX,Co,NewCo),
	pathConflictCheckMain(F1,F2,NewCo,Output,CoOut).
pathConflictCheckMain([F0|F1],F2,Co,Output,CoOut) :-
	!,
	Output = [F0|Out],
	pathConflictCheckMain(F1,F2,Co,Out,CoOut).

pathConflictCheckSub(F0,XX,Co,NewCo) :-
	F0 = [Path,Faci],
	XX == [Path,FaciX],
	!,
	NewCo = Co.
pathConflictCheckSub(F0,XX,Co,NewCo) :-
	F0 = [Path,Faci],
	!,
	Tmp = [XX|Co],
	NewCo = [F0|Tmp].

member1([Xp,[X,[Xin,[Xl,Xh]]]],FS,[Xp,[X,[Xin,[Yl,Yh]]]]) :-   
	member([Xp,[X,[Xin,[Yl,Yh]]]],FS),
	Xl =< Yh,                 %  bit width overlap
	Yl =< Xh.

ctlConflictCheck(_,error,_,error,[]) :- !.
ctlConflictCheck(error,_,_,error,[]) :- !.
ctlConflictCheck(F1,F2,Co,Output,CoOut) :-
	!,
	ctlConflictCheckMain(F1,F2,Co,Output,CoOut).

ctlConflictCheckMain([],F2,CO,F2,CO) :- !.
ctlConflictCheckMain([[Faci,Ctl]|F1],F2,Co,Output,CoOut) :-
	member([Faci,Ctl],Co),
	!,
	Output = Out,
	NewCo = Co,
	ctlConflictCheckMain(F1,F2,NewCo,Out,CoOut).
ctlConflictCheckMain([[Faci,Ctl]|F1],F2,Co,Output,CoOut) :-
	member([Faci,_],Co),
	!,
	Output = Out,
	NewCo = [[Faci,Ctl]|Co],
	ctlConflictCheckMain(F1,F2,NewCo,Out,CoOut).
ctlConflictCheckMain([[Faci,Ctl]|F1],F2,Co,Output,CoOut) :-
	member([Faci,X],F2),
	!,
	Output = Out,
	ctlConflictCheckSub(Faci,X,Ctl,Co,NewCo),
	ctlConflictCheckMain(F1,F2,NewCo,Out,CoOut).
ctlConflictCheckMain([[Faci,Ctl]|F1],F2,Co,Output,CoOut) :-
	!,
	Output = [F0|Out],
	NewCo = Co,
	ctlConflictCheckMain(F1,F2,NewCo,Out,CoOut).

ctlConflictCheckSub(Faci,X,Ctl,Co,NewCo) :-
	X == Path, 
	!,
	NewCo = Co.
ctlConflictCheckSub(Faci,X,Ctl,Co,NewCo) :-
	!,
	NewCo = [[Faci,Ctl]|[[Faci,X]|Co]].

