/*
	get operation which mean equal
	operation_expand
	operation_creat
*/

equal_op(In,Out) :-
	operationMain(In,Out).

systemOpTrans(In,Out) :-
	opSystem(In,Out).

operationMain(In,Out) :-
	opSystem(In,P1),
	opExch(P1,P2),
	opSameHandle(P2,P3),
	opUserHandle(P3,Out).

opSameHandle(In,Out) :-
	opNewSame(OpSet),
	member(In,OpSet),
	!,
	member(Out,OpSet).
opSameHandle(Op,Op).

opUserHandle(Op,Op).
opUserHandle(In,Out) :-
	opNewUser(In,Out).
opUserHandle(In,Out) :-
	opNewUser(Out,In).


%  bit manipulation
bitManipulate([low,[0,15]],[0,7]).
bitManipulate([high,[0,15]],[8,15]).
bitManipulate([cat,[0,7],[0,7]],[0,15]).


%	user define 
opUser([low,[X,[0,15]]],[X,[0,7]]).
opUser([high,[X,[0,15]]],[X,[8,15]]).

%	user define filtered system operation 
opNewUser([low,[X,[0,15]]],[X,[0,7]]).
opNewUser([high,[X,[0,15]]],[X,[8,15]]).

%	same mean operation by other facility
opSame([[*,X,2],[<<,X],[+,X,X]]).
opSame([[+,X,1],[incr,X]]).

%	same mean operation by other facility filtered system operation
opNewSame([[multi,X,2],[shift_left,X],[add,X,X]]).
opNewSame([[div,X,2],[shift_right,X]]).
opNewSame([[add,X,1],[incr,X]]).
% 	system operation
opSystem([/\,T1,T2],[and,T1,T2]) :- !.
opSystem([\/,T1,T2],[or,T1,T2]) :- !.
opSystem([*,T1,T2],[multi,T1,T2]) :- !.
opSystem([/,T1,T2],[div,T1,T2]) :- !.
opSystem([+,T1,T2],[add,T1,T2]) :- !.
opSystem([-,T1,T2],[sub,T1,T2]) :- !.
opSystem([<<,T],[shift_left,T]) :- !.
opSystem([>>,T],[shift_right,T]) :- !.
%opSystem([*,Term],[*,Term]) :- !.
%opSystem([&,Term],[&,Term]) :- !.
opSystem(Op,Op) :- !.

%	exchangeable argument
opExch(Op,Op).
opExch([and,T1,T2],[and,T2,T1]) :- T1 \== T2.
opExch([or,T1,T2],[or,T2,T1]) :- T1 \== T2.
opExch([multi,T1,T2],[multi,T2,T1]) :- T1 \== T2.
opExch([add,T1,T2],[add,T2,T1]) :- T1 \== T2.

%
%	operation expand and creat
%

operation_expand(Term,Expa,Var) :-
	Term =.. [Op,T1,T2],
	Expa =   [Op,E1,E2],
	!,
	operation_expand(T1,E1,Var1),
	operation_expand(T2,E2,Var2),
	append(Var1,Var2,Var).

operation_expand(Term,Expa,Var) :-
	Term =.. [Op,T1],
	Expa =   [Op,E1],
	!,
	operation_expand(T1,E1,Var).

operation_expand(Term,Term,[Term]) :-
	localVar(Term),
	!.

operation_expand(Term,Term,[]) :-
	!.

operationExpandList([],[]) :- !.
operationExpandList([X|L],[Y|LL]) :- 
	operationExpandList(L,LL),
	operation_expand(X,Y,_),
	!.



operation_creat(Term,Expa) :-
	Expa =   [Op,E1,E2],
	!,
	operation_creat(T1,E1),
	operation_creat(T2,E2),
	Term =.. [Op,T1,T2].

operation_creat(Term,Expa) :-
	Expa =   [Op,E1],
	!,
	operation_creat(T1,E1),
	Term =.. [Op,T1].

operation_creat(Term,Term) :-
	!.
