/*
pathSetSearch([],[],[],success,_,Tab) :-
	!.
*/
pathSetSearch(PathSet,Path,Ctl,Status,Faci,Tab) :-
	tab(Tab),write('Search connection from Source to Destination '),
	write('in the path set.'),nl,
	Tab1 is Tab + 2,
	pathSetSearchSub(PathSet,Path,Ctl,[],[],Pconf,Cconf,Tab1),
	getOpStatus(Pconf,Path,Cconf,Ctl,Status,Conf),
	opFaSub(Path,Ctl,Conf,Status,PathSet,Tab).
pathSetSearch(PathSet,Path,Ctl,Status,Faci,Tab) :-
%	Faci \== [],
	recorded(semaphore,PathSet,_),
	!,
%	tab(Tab),write('No other route when using facility "'),
%	write(Faci),write('".'),nl,
	tab(Tab),write('No other route for this path set.'),nl,
%	tab(Tab),write('Retry other facility'),nl,
	fail.
pathSetSearch(PathSet,Path,Ctl,Status,Faci,Tab) :-
%	Faci \== [],
	!,
%	tab(Tab),write('Fail when using facility "'),
%	write(Faci),write('".'),nl,
	tab(Tab),write('Fail for this path set.'),nl,
%	tab(Tab),write('Retry other facility'),nl,
	fail.
pathSetSearch(PathSet,Path,Ctl,Status,Faci,Tab) :-
	Faci == [],
	recorded(semaphore,PathSet,_),
	!,
	tab(Tab),write('No other route. '),
%	tab(Tab),write('Retry other facility'),nl,
	fail.
pathSetSearch(PathSet,Path,Ctl,Status,Faci,Tab) :-
	Faci == [],
	!,
	tab(Tab),write('Fail.'),nl,
%	tab(Tab),write('Retry other facility'),nl,
	fail.


pathSetSearchSub([],[],[],Pconf,Cconf,Pconf,Cconf,Tab) :-
	!.
pathSetSearchSub([(To,From)|Rest],Path,Ctl,Pconf0,Cconf0,Pconf,Cconf,Tab) :-
	pathSearch(To,From,P1,C1,S,Tab),
	S \== noOther,
	pathSetSearchSub(Rest,P2,C2,Pconf0,Cconf0,Pconf1,Cconf1,Tab),
	pathConflictCheck(P1,P2,Pconf1,Path,Pconf),
	ctlConflictCheck(C1,C2,Cconf1,Ctl,Cconf).

seekPathSet(To,From,PathSet,Faci,Tab) :-
	tab(Tab),write('Seek path set that should be searched.'),nl,
	Tab1 is Tab + 2,
	dstSeekPathSet(To,From,PS,Faci,Tab1),
						% PS is List of (T,F)
						%   T : port expression
						%   F : list of port expression
	dividePathSet(PS,PathSet),
						% PathSet is list of (TT,FF)
						%   TT,FF : port expression
	sPSsub(To,From,PathSet,Tab).
seekPathSet(To,From,PathSet,Faci,Tab) :-
	getStatus((set,To,From),Status),
	sPSsub2(Status,Tab),
	!,
	fail.

sPSsub(To,From,PathSet,Tab) :-
	recordz(semaphore,(set,To,From),_),
	tab(Tab),write('Success. Path set is '),write(PathSet),nl.
sPSsub(To,From,PathSet,Tab) :-
	tab(Tab),write('Retry other path set.'),nl,
	!,
	fail.

sPSsub2(Status,Tab) :-
	Status == fail,
	tab(Tab),write('Fail.'),nl.
sPSsub2(Status,Tab) :-
	Status == noOther,
	tab(Tab),write('No other path set.'),nl.

dividePathSet([],[]) :-  
	!.
dividePathSet([(To,From)|LL],DD) :-
	From = [[F,[Fout,[Fl,Fh]]]|_],
	!,
	separateBit(To,From,Set),    % when bit width mismatch, this pred fails
	dividePathSet(LL,NN),
	append(Set,NN,DD),
	!.
dividePathSet([(To,From)|LL],DD) :-
	!,
	dividePathSet(LL,NN),
	DD = [(To,From)|NN],
	!.

dstSeekPathSet(&To,From,PathSet,Faci,Tab) :-    % Destination Local Variable
	!,
	srcSeekPathSet(BW,From,InPaths,OutPort,Faci,Tab),
	PathSet = [ (&To,OutPort) | InPaths ].
dstSeekPathSet(*To,From,PathSet,Faci,Tab) :-     %  register
	!,
	newType(RegType,To),
	newFunc([set,[RegType,BW],[RegType,In]],_),
	srcSeekPathSet(BW,From,InPaths,OutPort,Faci,Tab),
	PathSet = [ ([To,In],OutPort) | InPaths ].
dstSeekPathSet(To,From,PathSet,Faci,Tab) :-     % port expression
	To = [T,[Tin,[Tl,Th]]],
	!,
	BW = [Tl,Th],
	srcSeekPathSet(BW,From,InPaths,OutPort,Faci,Tab),
	PathSet = [ (To,OutPort) | InPaths ].

srcSeekPathSet(BW,*From,[],[[From,Out]],[],Tab) :-    %  register
	atomic(From),
	!,
	newType(RegType,From),
	newFunc([conn,[RegType,Out],[RegType,_]],_),
	Out = [Port,BW].
srcSeekPathSet(BW,*From,[([Mem,[address,BWA]],OutA)|PS],[[Mem,Out]],Faci,Tab) :- 
	From =.. [Mem,Adr],
	!,
	newType(RegType,Mem),
	newFunc([conn,[RegType,Out],[RegType,_]],_),
	Out = [Port,BW],
	srcSeekPathSet(BWA,Adr,PS,OutA,Faci,Tab).
srcSeekPathSet(BW,&From,[],[[&From,[local,BW]]],[],Tab) :- % Dest. Local Var
	!.
srcSeekPathSet(BW,From,[],[[From,[const,BW]]],[],Tab) :-    %  Constant
	atomic(From),
	!.
srcSeekPathSet(BW,From,PathSet,OutPort,Faci,Tab) :-
	From =.. LL,
	!,
	srcSeekPathSetSub(LL,PathSet,OutPort,Faci,Tab).

srcSeekPathSetSub(From,PathSet,OutPort,Faci,Tab) :-
	From = [Op,L1,L2],
	bitManipulate([Op,BW1,BW2],Out),
	!,
	srcSeekPathSet(BW1,L1,InPaths1,Port1,Faci1,Tab),
	srcSeekPathSet(BW2,L2,InPaths2,Port2,Faci2,Tab),
	append(Port1,Port2,OutPort),
	append(Faci1,Faci2,Faci),
	append(InPaths1,InPaths2,PathSet).
srcSeekPathSetSub(From,PathSet,OutPort,Faci,Tab) :-
	From = [Op,L1],
	bitManipulate([Op,BW],Out),
	!,
	srcSeekPathSet(BW,L1,PathSet,Port,Faci,Tab),
	bitManipulation(Op,Port,OutPort).
srcSeekPathSetSub(From,PathSet,[OutPort],Faci,Tab) :-
	equalOperations(From,PathSet,OutPort,Faci,Status,Tab).

equalOperations(LL,InPaths,OutPort,Faci,Status,Tab) :-
	OD =.. LL,
	tab(Tab),write('Search equal operation. Original : '),
	write(OD),nl,
	equal_op(LL,EqOp),
	Tab1 is Tab + 2,
	equalOpMain(EqOp,InPaths,OutPort,Faci,Status,Tab1),
	eqOpSub(OD,Status,Tab).

equalOpMain(EqOp,InPaths,OutPort,Faci,Status,Tab) :-
	FF =.. EqOp,
	Tab1 is Tab + 2,
	tab(Tab),write('Equal operation : '),
	write(FF),nl,
	existFacility(EqOp,InPaths,OutPort,Faci,Status,Tab1),
	statusCheck(Status,FF,Tab).

equalOperations(LL,[],error,[],Status,Tab) :-
	tab(Tab),write('No other equal operations'),nl,
%	getStatus(LL,Status).   % Status = fail || noOther
	Status = noOther,
	fail.
eqOpSub(OD,Status,Tab) :-
	Status == success,
	tab(Tab),write('Success. Original : '),write(OD),nl.
eqOpSub(OD,Status,Tab) :-
%	Status == fail,
	tab(Tab),write('Original : '),write(OD),nl,
	!,
	fail.
/*
	existFacility(To,[Op,L1,L2],Path,Ctl,Status,Faci,Tab) 

    	check whether facility for Op exists
*/
existFacility([Op,L1,L2],InPaths,OutPort,Faci,Status,Tab) :-
	newFunc([Op,[FF,_],[FF,_],[FF,_]],_),
	newType(FF,_),
	!,
	searchFacility([Op,L1,L2],InPaths,OutPort,Faci,Status,Tab).
existFacility([Op,L1],InPaths,OutPort,Faci,Status,Tab) :-
	newFunc([Op,[FF,_],[FF,_]],_),
	newType(FF,_),
	!,
	searchFacility([Op,L1],InPaths,OutPort,Faci,Status,Tab).
existFacility([Op|LL],[],none,[],fail,Tab) :-
	tab(Tab),write('No facility. There is no facility for operation "'),
	write(Op),write('".'),nl,
	!.

searchFacility([Op,L1,L2],[([Faci,FaIn1],L1),([Faci,FaIn2],L2)],[Faci,FaOut],[Faci],success,Tab) :-
	newFunc([Op,[Fa,FaOut],[Fa,FaIn1],[Fa,FaIn2]],_),
	newType(Fa,Faci),
	sFaSub2(L1,L2,Faci,FaIn1,FaIn2,FaOut,Tab).
searchFacility([Op,L1],[([Faci,FaIn],L1)],[Faci,FaOut],[Faci],success,Tab) :-
	newFunc([Op,[Fa,FaOut],[Fa,FaIn]],_),
	newType(Fa,Faci),
	sFaSub1(L1,Faci,FaIn,FaOut,Tab).
searchFacility([Op|LL],[],none,[],noOther,Tab) :-
	tab(Tab),write('No other facility for operation "'),
	write(Op),write('".'),nl.

sFaSub2(L1,L2,Faci,FaIn1,FaIn2,FaOut,Tab) :-
	tab(Tab),write('Implement by using facility "'),
	write(Faci),write('".'),nl,
	tab(Tab),write('Path set that implement this operation is '),
	write([Faci,FaIn1]),write(' <- '),
	write((L1,[Faci,FaIn2])),write(' <- '),write(L2),nl,
	tab(Tab),write('and OutPort is '),write([Faci,FaOut]),nl.
sFaSub2(L1,L2,Faci,FaIn1,FaIn2,FaOut,Tab) :-
	tab(Tab),write('Retry for other facility.'),nl,
	!,
	fail.
sFaSub1(L1,Faci,FaIn,FaOut,Tab) :-
	tab(Tab),write('Implement by using facility "'),
	write(Faci),write('".'),nl,
	tab(Tab),write('Path set that implement this operation is '),
	write([Faci,FaIn]),write(' <- '),write(L1),nl,
	tab(Tab),write('and OutPort is '),write([Faci,FaOut]),nl.
sFaSub1(L1,Faci,FaIn,FaOut,Tab) :-
	tab(Tab),write('Retry for other facility.'),nl,
	!,
	fail.


