/*

	translator

*/

:-op(140,fx,'&').

cpu_time(X) :- statistics(runtime,[X1,_]),X is X1/1000.

tokio_trans([]) :- !.

tokio_trans([H|T]) :- !, tokio_trans(H),tokio_trans(T).

tokio_trans(A) :-
	seeing(Old),nofileerrors,see(A),!,
	read(X),clause_trans(X),
	seen,see(Old).

tokio_trans(File) :-
	fileerrors,
	display('Cannot open file: '), display(File),ttynl,!.

clause_trans('$function'(Function)) :- 
	!,
	read_function(Function),
	read(Next),
	clause_trans(Next).

clause_trans(end_of_file).

/* temp should be considered*/
clause_trans((Head :- Body)) :- 
	functor(Head,Head_name,Arity), 	
	Head =..[Head_name|Arguments],
	name(Head_name,P1),name(Arity,P2),
	concatenate([P1,"/",P2],PP),
	name(PredId,PP),
	unique_head(PredId,1,Head_num), 
	int_trans1(PredId,Head_num,1,Body,Cond1,Num_of_subint,Vars),
			% returning Cond and Number_of_subintervals
	operationExpandList(Cond1,Cond11),
	Clause_id = (PredId,Head_num),
	getCondition(PredId,1,Head_num,Cond2),
	notCondition(Cond2,Cond3),
	append(Cond3,Cond11,Cond),
	recordz(predicate,(Clause_id,Arguments,Cond,Num_of_subint),_),
%	recordz(local_var,(Clause_id,Vars),_),
	!,read(Next),clause_trans(Next).

clause_trans(( :- Body)) :- 
	functor(Body,op,3),!,
	call(Body),
	read(Next),
	clause_trans(Next).

clause_trans(( :- Body)) :- 
	functor(Body,static,1),
	!,
	read(Next),
	clause_trans(Next).

clause_trans(X) :- clause_trans((X :- true)).

getCondition(PredName,Cnum,Cnum,[]) :- !.
getCondition(PredName,Cnum,Hnum,Cond) :-
	!,
	Ncnum is Cnum + 1,
	recorded(predicate,((PredName,Cnum),Arg,Cond1,NS),_),
	getCondition(PredName,Ncnum,Hnum,Cond2),
	append(Cond1,Cond2,Cond).

notCondition([],[]) :- !.
notCondition([X|L],[Y|LL]) :- 
	!,
	notConditionOne(X,Y),
	notCondition(L,LL).

notConditionOne(X,Y) :-
	notCond(X,Y),
	!.
notConditionOne(X,Y) :-
	notCond(Y,X),
	!.
notConditionOne(X,[not,X]) :-
	!.

notCond([=,A,B],[\=,A,B]) :- !.
notCond([>=,A,B],[<,A,B]) :- !.
notCond([=<,A,B],[>,A,B]) :- !.
notCond([==,A,B],[\==,A,B]) :- !.
notCond([=:=,A,B],[=\=,A,B]) :- !.

%%%	not developed yet
read_function(F) :- true.
	
/* finding unique number for Head_name H */
unique_head(PredName,Head_num,Unique) :-
	recorded(predicate,((PredName,Head_num),_),_),
	!,
	NHead_num is Head_num + 1,
	unique_head(PredName,NHead_num,Unique).
unique_head(PredName,Num,Num).

%	int_trans1(HH,NN,Hnum,1,Body,,Cond,Num_of_subint),
int_trans1(PredId,Hnum,Inum,(Int '&&' Int1),Cond,Num_of_subint,Vars) :- 
	find_cond(Int,Cond,Rest,ok),
	!,
	start_sub_int_trans((PredId,Hnum,Inum),Rest,Vars1),
	NInum is Inum + 1,
	int_trans2(PredId,Hnum,NInum,Int1,Num_of_subint,Vars2),
	append(Vars1,Vars2,Vars).

int_trans1(PredName,Hnum,Inum,(Int '&&' Int1),[],Num_of_subint,Vars) :- 
	!, 
	start_sub_int_trans((PredName,Hnum,Inum),Int,Vars1), 
	NInum is Inum + 1,
	int_trans2(PredName,Hnum,NInum,Int1,Num_of_subint,Vars2),
	append(Vars1,Vars2,Vars).

int_trans1(PredName,Hnum,Inum,Int,Cond,1,Vars) :- 
	find_cond(Int,Cond,Rest,ok),
	!,
	start_sub_int_trans((PredName,Hnum,Inum),Rest,Vars).

int_trans1(PredName,Hnum,Inum,Int,[],1,Vars) :- 
	!,
	start_sub_int_trans((PredName,Hnum,Inum),Int,Vars).

int_trans2(PredName,Hnum,Inum,(Int '&&' Int1),Num_of_subint,Vars) :- 
	!,
	start_sub_int_trans((PredName,Hnum,Inum),Int,Vars1),
	NInum is Inum + 1,
	int_trans2(PredName,Hnum,NInum,Int1,Num_of_subint,Vars2),
	append(Vars1,Vars2,Vars).

int_trans2(PredName,Hnum,Inum,Int,Inum,Vars) :- 
	!,
	start_sub_int_trans_2((PredName,Hnum,Inum),Int,Vars).


/* find_cond(Int,Cond,Rest,Flag)	returns 
	if there are any condition
		Flag--> ok
		Cond--> list of conditions required for the interval
		Rest--> actions except for condition
	else 
		Flag--> no
		Cond--> list of actions
		Rest--> []
*/

find_cond(!,[],[],ok) :- !.
find_cond((!,A),[],(A),ok) :- !.
find_cond((A,B),[A|X],Rest,Flag) :- !,find_cond((B),X,Rest,Flag).
find_cond((B),[B],[],no) :- !.

varAppend(V0,V9) :-
	varAppend1(V0,[],RR),
	varSelect(RR,[],V9).

varAppend1([],PP,PP).

varAppend1([S1|SS],PP,RR) :-
	S1 = [Vars,Clock],
	Vars \== [],
	(
	member([VV,Clock],PP),
	appendSub(Vars,VV,Vnew)
	;
	Vnew = Vars
	),
	!,
	varAppend1(SS,[[Vnew,Clock]|PP],RR).

varAppend1([S1|SS],PP,RR) :-
	!,
	varAppend1(SS,PP,RR).
appendSub([],[],[]) :- !.
appendSub([],L2,L2) :- 
	!,
	appendSub(L2,[],LL).
appendSub([X|L1],L2,NN) :-
	appendSub(L1,L2,N),
	(
	member(X,N),NN = N
	;
	NN = [X|N]
	),
	!.

varSelect([],CL,[]) :- !.

varSelect([R1|RR],CL,Out) :-
	R1 = [Vars,C1],
	(
	member(C1,CL),
	Out = NN
	;
	Out = [R1|NN]
	),
	!,
	varSelect(RR,[C1|CL],NN).



start_sub_int_trans(SubintId,T,[[Inum,Vars]]) :-
	SubintId = (PredName,Hnum,Inum),
	sub_int_trans(SubintId,T,1,NDT,1,Stop_cond,More_cond,Vars,Length,Sc_flag),
	%	recordz(local_var,(SubintId,Vars),_),
	( integer(Length),
	  !,
	  recordz(sub_int,(SubintId,Stop_cond,More_cond,Length,NDT),_)
	;
	  Sc_flag == call,!,
	  recordz(sub_int,(SubintId,Stop_cond,More_cond,plus,NDT),_)
	;
	  Sc_flag == true,!,
	  recordz(sub_int,(SubintId,Stop_cond,More_cond,plus,NDT),_)
	;
	  !,
	  recordz(sub_int,(SubintId,Stop_cond,More_cond,1,NDT),_)
	).

start_sub_int_trans_2(SubintId,T,[[Inum,Vars]]) :-
	SubintId = (PredName,Hnum,Inum),
	sub_int_trans(SubintId,T,1,NDT,1,Stop_cond,More_cond,Vars,Length,Sc_flag),
	%	recordz(local_var,(SubintId,Vars),_),
	( integer(Length),
	  !,
	  recordz(sub_int,(SubintId,Stop_cond,More_cond,Length,NDT),_)
	;
	  Sc_flag == call,!,
	  recordz(sub_int,(SubintId,Stop_cond,More_cond,plus,NDT),_)
	;
	  Sc_flag == true,!,
	  recordz(sub_int,(SubintId,Stop_cond,More_cond,notMinus,NDT),_)
	;
	  !,
	  recordz(sub_int,(SubintId,Stop_cond,More_cond,1,NDT),_)
	).

%%	sub_int_trans(head_name,arity,unique_head_number,
%%		unique_interval_number,(terms),
%%		stop_cond,more_cond,Length,State_call_flag).
%%					1 :- if state_calls exist
%%					Var :- if state_calls don't exist

sub_int_trans(SubintId,(T,Terms),TrId,NDT,ClId,Sc,Mc,Vars,Length,Flag) :-
	!,
	term_trans(SubintId,T,(0,beg),0,TrId,NTrId,ClId,NClId,Sc0,Mc0,Vars1,Length,Flag),
	sub_int_trans(SubintId,Terms,NTrId,NDT,NClId,Sc1,Mc1,Vars2,Length,Flag),
	append(Sc0,Sc1,Sc),
	append(Mc0,Mc1,Mc),
	append(Vars1,Vars2,Vars3),
	varAppend(Vars3,Vars).

sub_int_trans(SubintId,T,TrId,NDT,ClId,Sc,Mc,Vars,Length,Flag) :-
	!,
	term_trans(SubintId,T,(0,beg),0,TrId,NtrId,ClId,_,Sc,Mc,V1,Length,Flag),
	NDT is NtrId - 1,
	varAppend(V1,Vars).

init_trans :-
	clear_record(dependOn),
	clear_record(sameTimeHappen),
	clear_record(notHappen),
	clear_record(already),
	clear_record(facility),
	clear_record(path),
	clear_record(semaphore),
	clear_record(max_id),
	clear_record(same_time),
	clear_record(new_call),
	clear_record(imag_predid),
	clear_record(imag_reg),
	clear_record(predicate),
	clear_record(local_var),
	clear_record(data_trans),
	clear_record(data_equal),
	clear_record(ground_subint),
	clear_record(sub_int),
	clear_record(caller),
	clear_record(conflict),
	clear_record(stateConflict),
	clear_record(stateSet),
	clear_record(state_call).

result :-
	show_record(predicate),
%	show_record(local_var),
	show_record(state_call),
	show_record(sub_int),
	show_record(data_equal),
	show_record(data_trans).

show_record(Key) :-
	recorded(Key,X,Ref),
	write((Key,X)),put(46),nl,fail.
show_record(Key).

clear_record(Key) :-
	recorded(Key,X,Ref),
	erase(Ref),fail.
clear_record(Key) :- 
	!.
