/*
	structure.pl

	structure expand and bit_width completion
*/

cas :- 
	!,
	clearAllStructure.

clearAllStructure :-
	retractall(path(A,B,C,D)),
	fail.
clearAllStructure :-
	retractall(path(A,B,C)),
	fail.
clearAllStructure :-
	retractall(func(A,B)),
	fail.
clearAllStructure :-
	retractall(type(A,B,C)),
	fail.
clearAllStructure :-
	retractall(type(A,B)),
	fail.
clearAllStructure :-
	retractall(bit_width(A,B)),
	fail.
clearAllStructure :-
	!,
	clearCreatedData.

clearCreatedData :-
	retractall(tmpPath(A,B,C)),
	fail.
clearCreatedData :-
	retractall(newPath(A,B,C)),
	fail.
clearCreatedData :-
	retractall(newFunc(A,B)),
	fail.
clearCreatedData :-
	retractall(newType(A,B)),
	fail.
clearCreatedData :-
	!.

expandStructure :-
	assertz((type(A,B,C):-!,fail)),
	assertz((path(A,B,C,D):-!,fail)),
	fail.
expandStructure :-
	type(A,B,M),
%	A \== module,
	completeModule(M,CM),
	expandName(CM,B,MB),
	assertz(newType(A,MB)),
	fail.
expandStructure :-
	path(A,B,C,M),
	completeModule(M,CM),
	expandName(CM,A,MA),
	expandTansi(CM,B,MB),
	expandTansi(CM,C,MC),
	assertz(tmpPath(MA,MB,MC)),
	fail.
expandStructure :-
	type(A,B),
	assertz(newType(A,B)),
	fail.
expandStructure :-
	path(A,B,C),
	assertz(tmpPath(A,B,C)),
	fail.
expandStructure.


expandTansi(CM,[Fa,IO],Out) :-
	!,
%	expandName(CM,IO,New),
	expandName(CM,Fa,NewFa),
	Out = [NewFa,IO].
expandTansi(CM,Fa,Out) :-
	atomic(Fa),
	!,
	expandName(CM,Fa,Out).
expandTansi(CM,Fa,Fa) :-
	!.

expandName([],A,A) :- !.          %  top level
expandName(MC,A,New) :-
	name(A,AA),
	append(MC,AA,NN),
	name(New,NN).

completeModule(top,[]) :- !.
completeModule(Mtype,C) :-
	type(Mtype,S,T),
	name(S,SS),
	completeModule(T,TT),
	concatenate([TT,SS,"."],C).

bitWidth :-
	assertz((tmpPath(A,B,C):-!,fail)),
	fail.
bitWidth :-
	tmpPath(A,B,C),
	bitWidthSub(B,BB),
	bitWidthSub(C,CC),
	assertz(newPath(A,BB,CC)),
	fail.
bitWidth :-
	func(Operation,Ctl),
	Operation = [Func|Input],
	bitWidthList(Input,NewInput),
	NewOperation = [Func|NewInput],
	assertz(newFunc(NewOperation,Ctl)),
	fail.
bitWidth.

bitWidthSub([Fa,IO],Out) :-
	!,
	bitWidthOne(IO,New),
	Out = [Fa,New].
bitWidthSub(Fa,Out) :-
	atomic(Fa),
	!,
	bitWidthOne(Fa,Out).
bitWidthSub(Fa,Fa) :-
	!.

bitWidthOne([IO,[Low,High]],[IO,[Low,High]]) :-
	!.
bitWidthOne(IO,[IO,Default]) :-
	bit_width(A,B),
	!,
	Default = [A,B].
bitWidthOne(_,_) :-
	!,
	display('Default bit width is not defined.'),ttynl,
	fail.

bitWidthList([],[]) :- !.
bitWidthList([X|L],[XX|LL]) :-
	!,
	bitWidthList(L,LL),
	bitWidthSub(X,XX).

