/*
	term_trans
*/
%%    term_trans(SubintId.Term,Beg_clock,Fin_clock,Ass0,Assign,Ref0,Refer,Sc0,Mc0,Mc,Length,Flag)
%%					   currently handled clock
%%		Beg_clock,Fin_clock = 	(0,beg),0 ---- ordinary
%%					(1,beg),0 ---- next
%%					(0,al),0  ---- always
%%					(0,al),-1 ---- keep   
%%					(1,al),0  ---- @ always
%%					(1,al),-1 ---- @ keep

term_trans(SubintId,length(L),(Beg_c,St),Fin_c,TrId,TrId,ClId,ClId,[],[],[],L1,F) :-
	( var(L1),!,L1 = L ;
	write(('length_conflict happens here',SubintId)),nl).

term_trans(SubintId,skip,(Beg_c,St),Fin_c,TrId,TrId,ClId,ClId,[],[],[],L,F) :-
	( var(L),!,L = 1 ;
	write(('length_conflict happens here',SubintId)),nl).

term_trans(SubintId,empty,(Beg_c,St),Fin_c,TrId,TrId,ClId,ClId,[],[],[],L,F) :-
	( var(L),!,L = 0 ;
	write(('length_conflict happens here',SubintId)),nl).

term_trans(SubintId,more(Term),(Beg_c,St),Fin_c,TrId,TrId,ClId,ClId,[],[Term],[],L,F).

term_trans(SubintId,stop(Term),(Beg_c,St),Fin_c,TrId,TrId,ClId,ClId,[Term],[],[],L,F).

term_trans(SubintId,keep(Term),(Beg_c,St),Fin_c,TrId,TrId1,ClId,ClId1,Sc,Mc,Vars,L,F) :-
	NF is Fin_c - 1,
	term_trans(SubintId,Term,(Beg_c,al),NF,TrId,TrId1,ClId,ClId1,Sc,Mc,Vars,L,F).


term_trans(SubintId,#Term,(Beg_c,St),Fin_c,TrId,TrId1,ClId,ClId1,Sc,Mc,Vars,L,F) :-
	term_trans(SubintId,Term,(Beg_c,al),Fin_c,TrId,TrId1,ClId,ClId1,Sc,Mc,Vars,L,F).

term_trans(SubintId,@T,(Beg_c,St),Fin_c,TrId,TrId1,ClId,ClId1,Sc,Mc,Vars,L,F) :-
	NC is Beg_c + 1,
	term_trans(SubintId,T,(NC,St),Fin_c,TrId,TrId1,ClId,ClId1,Sc,Mc,Vars,L,F).


term_trans(SubintId,A = B,(Beg_c,beg),Fin_c,TrId,TrId,ClId,ClId,[],[],Vars,L,F):- 
	operation_expand(B,BB,V2),
	operation_expand(A,AA,V1),
	append(V1,V2,V3),
	[[V3,Beg_c]] = Vars,
	recordz(data_equal,(SubintId,(AA,BB),Beg_c),_).

term_trans(SubintId,A = B,(Beg_c,al),Fin_c,TrId,TrId,ClId,ClId,[],[],Vars,L,F):- 
	operation_expand(B,BB,V2),
	operation_expand(A,AA,V1),
	append(V1,V2,V3),
	[[V3,[Beg_c,Fin_c]]] = Vars,
	recordz(data_equal,(SubintId,(AA,BB),[Beg_c,Fin_c]),_).

term_trans(SubintId,*A := B,(Beg_c,_),Fin_c,TrId,TrId,ClId,ClId,[],[],Vars,L,F):- 
	write(('This assignment can not be handled.',*A := B)),nl.

term_trans(SubintId, A <- B,(Beg_c,beg),Fin_c,TrId,NtrId,ClId,ClId,[],[],Vars,L,F) :-
	operation_expand(B,BB,V2),
	operation_expand(A,AA,V1),
	[[V1,fin],[V2,Beg_c]] = Vars,
	NtrId is TrId + 1,
	recordz(data_trans,(SubintId,TrId,(A,fin),(B,Beg_c)),_),
	imag_reg_name(ImagReg),
	recordz(data_equal,(SubintId,(A,['&',ImagReg]),fin),_).

term_trans(SubintId, A <- B,(Beg_c,al),Fin_c,TrId,TrId,ClId,ClId,[],[],[],L,F) :-
	write(('The timing of this term cannot be handled',A <- B)),nl. 

term_trans(SubintId,*A <= B,(Beg_c,beg),Fin_c,TrId,NtrId,ClId,ClId,[],[],Vars,L,F) :-
	operation_expand(B,BB,V2),
	operation_expand(*A,AA,V1),
	[[V1,fin],[V2,Beg_c]] = Vars,
	NtrId is TrId + 1,
	recordz(data_trans,(SubintId,TrId,(*A,fin),(B,Beg_c)),_).

term_trans(SubintId,*A <= B,(Beg_c,al),Fin_c,TrId,TrId,ClId,ClId,[],[],[],L,F) :-
	write(('The timing of this term cannot be handled',*A <= B)),nl. 

term_trans(SubintId,beg(T),(Beg_c,St),Fin_c,TrId,TrId1,ClId,ClId1,Sc,Mc,Vars,L,F) :-
	term_trans(SubintId,T,(Beg_c,beg),Fin_c,TrId,TrId1,ClId,ClId1,Sc,Mc,Vars,L,F).

term_trans(SubintId,fin(T),(Beg_c,St),Fin_c,TrId,TrId1,ClId,ClId1,Sc,Mc,Vars,L,F) :-
	term_trans(SubintId,T,(fin - Fin_c,beg),Fin_c,TrId,TrId1,ClId,ClId1,Sc,Mc,Vars,L,F).

term_trans(SubintId,Term,(Beg_c,St),Fin_c,TrId,TrId,ClId,ClId,[],[],[],L,F) :-
	functor(Term,write,_),!.

term_trans(SubintId,Term,(Beg_c,St),Fin_c,TrId,TrId,ClId,ClId,[],[],[],L,F) :-
	functor(Term,fail,_),!,
	write(('RTL-Tokio do not allow backtrack.  ')),
	write((SubintId,Term)),nl.

term_trans(SubintId,Term,(Beg_c,St),Fin_c,TrId,TrId,ClId,ClId,[],[],[],L,true) :-
	functor(Term,true,_),!.

term_trans(SubintId,Term,(Beg_c,St),Fin_c,TrId,TrId,ClId,ClId,[],[],[],L,F) :-
	functor(Term,nl,_),!.

term_trans(SubintId,Term,(Beg_c,beg),Fin_c,TrId,TrId,ClId,NclId,[],[],[],L,call) :-
	Term = ( T1 '&&' T2 ),
	!,
%	trace,
	newClauseHead(SubintId,HeadName,NH),
	int_trans2('???',1,1,Term,Num_of_subint,Vars),
	makeArg(Vars,LA),
	Head =.. [HeadName|LA],	
	functor(Head,HeadName,Arity),
	name(Arity,P2),
	concatenate([NH,"/",P2],PP),
	name(PredName,PP),
	correctRecord(PredName),
	ClauseId = (PredName,1),
	recordz(predicate,(ClauseId,LA,[],Num_of_subint),_),
%	recordz(local_var,(ClauseId,Vars),_),
	NclId is ClId + 1,
	recordz(state_call,(SubintId,Beg_c,ClId,PredName,LA),_).

newClauseHead((PredName,HeadNum,SubintNum),NewHeadName,NameOfHead) :-
	!,
	name(PredName,L1),
	name(HeadNum,L3),
	name(SubintNum,L4),
	imagPredId(PredId),
	name(PredId,L5),
	concatenate(["##",L1,"-",L3,"-",L4,"-",L5,"##"],NameOfHead),
	name(NewHeadName,NameOfHead).

imagPredId(Num) :-
	recorded(imag_predid,X,Key),!,
	Num is X + 1,
	erase(Key),
	recordz(imag_predid,Num,_).
imagPredId(X) :-
	!,
	X = 1,
	recordz(imag_predid,X,_).
	
correctRecord(PredName) :-
	recorded(state_call,(('???',Hnum,SubintNum),X),Ref),
	recordz(state_call,((PredName,Hnum,SubintNum),X),_),
	erase(Ref),
	fail.

correctRecord(PredName) :-
	recorded(sub_int,(('???',Hnum,SubintNum),X),Ref),
	recordz(sub_int,((PredName,Hnum,SubintNum),X),_),
	erase(Ref),
	fail.

correctRecord(PredName) :-
	recorded(data_equal,(('???',Hnum,SubintNum),X),Ref),
	recordz(data_equal,((PredName,Hnum,SubintNum),X),_),
	erase(Ref),
	fail.

correctRecord(PredName) :-
	recorded(data_trans,(('???',Hnum,SubintNum),X),Ref),
	recordz(data_trans,((PredName,Hnum,SubintNum),X),_),
	erase(Ref),
	fail.

correctRecord(PredName).

makeArg([],[]).
makeArg([[Inum,V1]|Vars],Arg) :-
	makeArg1(V1,A1),
	makeArg(Vars,A2),
	append(A1,A2,Arg).

makeArg1([],[]).
makeArg1([[V1,C1]|Vars],Arg) :-
	makeArg1(Vars,V2),
	append(V1,V2,Arg).

term_trans(SubintId,Term,(Beg_c,beg),Fin_c,TrId,TrId,ClId,NclId,[],[],[],L,call) :-
	functor(Term,HeadName,Arity),!,
	Term =.. [Pred|LA],		% LA = List of Arguments
	NclId is ClId + 1,
	name(HeadName,P1),name(Arity,P2),
	concatenate([P1,"/",P2],PP),
	name(PredName,PP),
	recordz(state_call,(SubintId,Beg_c,ClId,PredName,LA),_).

term_trans(SubintId,Term,(Beg_c,al),Fin_c,TrId,TrId,ClId,NclId,[],[],[],L,call) :-
	functor(Term,HeadName,Arity),!,
	Term =.. [Pred|LA],		% LA = List of Arguments
	NclId is ClId + 1,
	name(Headname,P1),name(Arity,P2),
	concatenate([P1,"/",P2],PP),
	name(PredName,PP),
	recordz(state_call,(SubintId,[Beg_c,Fin_c],ClId,PredName,LA),_).

term_trans(SubintId,Term,(Beg_c,St),Fin_c,TrId,TrId,ClId,ClId,[],[],[],L,F) :-
	write(('This term cannot be handled now',Term)).

imag_reg_name(ImagReg) :-
	!,
	imag_reg_num(Num),	
	name(Num,LN),append("reg",LN,LL),
	name(ImagReg,LL).

imag_reg_num(Num) :-
	recorded(imag_reg,X,Key),!,
	Num is X + 1,
	erase(Key),
	recordz(imag_reg,Num,_).

imag_reg_num(0) :-
	!,
	recordz(imag_reg,0,_).





