
substituteForOp([Op,L1,L2],SubintId,Clock,Out,Called) :-
	!,
	substituteForOp(L1,SubintId,Clock,T1,Called1),
	substituteForOp(L2,SubintId,Clock,T2,Called2),
	systemOpTrans([Op,T1,T2],Out),
	longer(Called1,Called2,Called).

substituteForOp([Op,L1],SubintId,Clock,Out,Called) :-
	!,
	substituteForOp(L1,SubintId,Clock,T1,Called),
	systemOpTrans([Op,T1],Out).
	
substituteForOp(Var1,SubintId1,Clock1,Reg,Called) :-
	localVar(Var1),
	!,
	unifyAll(Var1,SubintId1,Clock1,Var2,SubintId2,Clock2,C1,Calling),
	recorded(data_equal,(SubintId2,(Var2,Var3),Clock2),_),
	substituteForOp(Var3,SubintId2,Clock2,Reg,C2),
	reverse(Calling,RR),
	listSub(RR,C3,C2),
	append(C1,C3,Called).

listSub(S2,Out,S1) :-
	append(S2,Out,S1),
	!.
listSub(_,Out,_) :-
	!,
	Out = [].

substituteForOp(Var,SubintId,Clock,Var,[]) :-
	!.
	
%	Called  List : right calls left
%	Calling List : left  calls right
%
unifyAll(Var,SubintId,Clock,Var1,SubintId1,Clock1,Called,Calling) :-
	unifyNextPrevInt(Var,SubintId,Clock,Var2,SubintId2,Clock2),
	unifyCC(Var2,SubintId2,Clock2,Var1,SubintId1,Clock1,Called,Calling).

unifyCC(Var,SubintId,Clock,Var2,SubintId2,Clock2,[],Calling) :-
	unifyC(Var,SubintId,Clock,Var2,SubintId2,Clock2,Calling).

unifyCC(Var,SubintId,Clock,Var2,SubintId2,Clock2,[(SubintId1,Clock1)|Called],Calling) :-
	unifyCalled(Var,SubintId,Clock,Var1,SubintId1,Clock1),
	unifyAll(Var1,SubintId1,Clock1,Var2,SubintId2,Clock2,Called,Calling).

unifyC(Var,SubintId,Clock,Var,SubintId,Clock,[]) :-
	true.

unifyC(Var,SubintId,Clock,Var3,SubintId3,Clock3,[(SubintId,Clock)|Calling]) :-
	unifyCall(Var,SubintId,Clock,Var2,SubintId2,Clock2),
	unifyC(Var2,SubintId2,Clock2,Var3,SubintId3,Clock3,Calling).

unifyNextPrevInt(Var1,SubintId1,Clock1,Var2,SubintId2,Clock2) :-
	sameClock(SubintId1,Clock1,SubintId2,Clock2),
	Var1 = Var2.

unifyCalled(Var1,SubintId1,Clock1,Var2,SubintId2,Clock2) :-	%  2 calls 1
	SubintId1 = (_,_,1),
	Clock1 == 0,
	unifyCall(Var2,SubintId2,Clock2,Var1,SubintId1,Clock1).	

unifyCall(Var1,SubintId1,Clock1,Var2,SubintId2,Clock2) :-	%  1 calls 2
	SubintId2 = (PredName9,ClauseNum,SubintNum),
	recorded(state_call,(SubintId1,Clock0,Id,PredName9,Arg1),_),
	member(Var1,Arg1),
	recorded(predicate,((PredName9,ClauseNum),Arg9,Cond,NumOfSubint),_),
	makePairs(Arg1,Arg9,VarPairs),
	member([Var1,Var2],VarPairs),
	(
	( Clock0 = Clock1,			% beg only
	  SubintNum = 1,
	  Clock2 = 0 
		% genmitu niha Clock0-Clock1 == Clause9 deno tousi Clock
		% not only beg
	)
	;
	( Clock1 = fin,				% fin
	  SubintNum = NumOfSubint,
	  Clock2 = fin
	)
	).
	


/*
	write(('Error: this cannot be handled',SubintId,Clock,Var1)),nl,!.
*/

longer(L1,L2,Out) :-
	(
	append(L2,_,L1),Out = L1
	;
	append(L1,_,L2),Out = L2
	),
	!.
	
sameClock(SubintId1,Clock1,SubintId2,Clock2) :-
	!,
	(
	(SubintId1,Clock1) = (SubintId2,Clock2)
	;
	(Clock1 = 0,Clock2 = fin,
	prevNextSubint(SubintId1,SubintId2))
%	;
%	(Clock1 = fin,Clock2 = 0,
%	prevNextSubint(SubintId2,SubintId1))
	).

prevNextSubint(Next,Prev) :-
	!,
	Next = (PredName,HeadNum,NintNum),
	Prev = (PredName,HeadNum,PintNum),
	(
	(integer(PintNum),NintNum is PintNum + 1 )
	;
	(integer(NintNum),PintNum is NintNum - 1,PintNum =\= 0 )
	).

localVar(Var) :-
	!,
	name(Var,[X|_]),
	( ( X >= 65 , X =< 90 ) ;( X= 95 ) ).

makePairs([],[],[]) :- !.

makePairs([Src|RestSrcs],[New|RestNews],VarPairs) :-
	!,
	VarPairs = [[Src,New]|VPairs0],
	makePairs(RestSrcs,RestNews,VPairs0).

reverse(A,B) :- rev_aux(A,[],B).
rev_aux([],A,A).
rev_aux([H|T],Aux,C) :- rev_aux(T,[H|Aux],C).

