/*
%  bit manipulation
bitManipulate([low,[0,15]],[0,7]).
bitManipulate([high,[0,15]],[8,15]).
bitManipulate([cat,[0,7],[0,7]],[0,15]).
*/
bitManipulation(Op,InPort,OutPort) :-   % InPort & OutPort is List of Port
	bitManipulate([Op,[Bl,Bh]],[Nl,Nh]),
	Fsb is Nl - Bl,
	skipNotOut(InPort,Fsb,PP),
	Gbw is Nh - Nl + 1,
	getOut(PP,Gbw,OutPort,Rest),
	Lsb is Bh - Bl + 1 - Fsb - Gbw,
	skipNotOut(Rest,Lsb,RR),
	RR == [].

skipNotOut(Port,0,Port) :-
	!.
skipNotOut([P0|Rest],BW,Port) :-
	P0 = [F,[Fio,[Fl,Fh]]],
	Ftmp is Fl + BW,
	Ftmp =< Fh,
	!,
	Port = [ [F,[Fio,[Ftmp,Fh]]]|Rest ].
skipNotOut([P0|Rest],BW,Port) :-
	P0 = [F,[Fio,[Fl,Fh]]],
	Fw is Fh - Fl + 1,
	Nbw is BW - Fw,
	Nbw >= 0,
	!,
	skipNotOut(Rest,Nbw,Port).
getOut(Port,0,[],Port) :-
	!.
getOut([P0|Rest],BW,Out,Extra) :-
	P0 = [F,[Fio,[Fl,Fh]]],
	Ftmp is Fl + BW - 1,
	Ftmp =< Fh,
	!,
	Out = [ [F,[Fio,[Fl,Ftmp]]] ],
	Fnb is Ftmp + 1,
	getOutSub([F,[Fio,[Fnb,Fh]]],Rest,Extra).
getOut([P0|Rest],BW,Out,Extra) :-
	P0 = [F,[Fio,[Fl,Fh]]],
	Fw is Fh - Fl + 1,
	Nbw is BW - Fw,
	Nbw > 0,
	!,
	getOut(Rest,Nbw,Port,Extra),
	Out = [ P0 | Port ].

getOutSub([F,[Fio,[Fnb,Fh]]],Rest,Extra) :-
	Fnb > Fh,
	!,
	Extra = Rest.
getOutSub([F,[Fio,[Fnb,Fh]]],Rest,Extra) :-
	!,
	Extra = [ [F,[Fio,[Fnb,Fh]]]|Rest ].


separateBit([T,[Tin,[Tl,Th]]],FF,Out) :-
	Tl > Th,
	!,
	Tl =:= Th + 1,
	FF == [],
	Out = [].
separateBit([T,[Tin,[Tl,Th]]],[F0|F1],[Set|Out]) :-
	F0 = [F,[Fout,[Fl,Fh]]],
	BW is Fh - Fl,
	Ttmp is Tl + BW,
	Set = ([T,[Tin,[Tl,Ttmp]]],F0),
	Tnb is Ttmp + 1,
	separateBit([T,[Tin,[Tnb,Th]]],F1,Out).
	
	
